#ifndef PAIRS_H
#define PAIRS_H

typedef struct Pair_struct Pair;
typedef struct Pairs_struct Pairs;

struct Pair_struct {
	char* name;
	void* value;
	Pair* next;
};

struct Pairs_struct {
	Pair** pairs;
	unsigned size;
	void* (*freeFunction)(void*);

	unsigned count;
	Pair* last;
	unsigned lastHash;
};



Pairs* newPairs(int size, void* (*freeFunction)(void*));
Pairs* freePairs(Pairs* pairs);
Pair* setPair(Pairs* pairs, char* name, void* value);
void* getPair(Pairs* pairs, char* name);
Pair* getPairPtr(Pairs* pairs, char* name);
int delPair(Pairs* pairs, char* name);
int renamePair(Pairs* pairs, char* name, char* new);
void startListPairs(Pairs* pairs);
Pair* nextPair(Pairs* pairs);
Pair** sortPairsByName(Pairs* pairs);
Pair** sortPairsByStrValue(Pairs* pairs);


#endif

