#ifndef STR_H
#define STR_H
#include <stdlib.h>

#include "configure.h"

int hexDigit(char c);
int iswalnum_(wchar_t wc);

char* unhash(char* str);
char* unescape(char* string);
char* unescapeURI(char* str);

char* escape(char* string);
char* escapeLink(char* string);

char* quote(char* string);
char* quotes(char* string);

void sql_unescape(char* string, ...);
void remove_cr(char* string, ...);
char* chomp(char* str);
char* trimSpaces(char* string);
char* strtolower(char* s);
char toLower(char c);
void tr(char* from, char* to, ...);

char* utf_strtolower(char* s);
int utf_strlen(char* s);
char* splitLongString(char* str);


int catstr(char* string, int max_size, ...);
char* cat_strings(char* string, ...);
char* add_strings(char** string, ...);
char* add_string(char** string, char* add);

unsigned hash(char *s);

char isAlNum(char c);
char isSpace(char c);
char isDigit(char c);
char isChar(unsigned char c);
char isSafe(char c);

char* itoa(long n);
char* itos(long n);
long long hex2ll(char* s);

unsigned string2ip(char* string);
char* ip2string(unsigned ip);

int reverse(char* s);

extern char toLower_[256];
void initToLower();
char* copystring(char* string);

int split(char* string, char* del, int max_len, ...);

char* fmt(char* format, ...);


char* long2str(unsigned u);
char* longs2str(unsigned u1, unsigned u2);
long str2long(char* str);

char checkEmail(char* email);
char checkPassword(char* password);
char checkNick(char* nick);
char checkDomain(char* domain);
char checkSlice(char* slice);
char checkAscii(char* s);

int stripLast(char* url, int length);

char unifyURL(char* url, char** host, char** query, char canBeShort);

char* humanSize(long long size);
char* humanPeriod(int period);

char* strncpy_(char* dest, char* src, int maxLength);


#define SNPRINTF(string, length, fmt, X...) snprintf__(__FILE__, __LINE__, string, length, fmt, ##X)
int snprintf__(char* file, int pos, char* string, int length, char* fmt, ...);


#define PUT(object) {\
	memcpy(ptr, &(object), sizeof(object)); \
	ptr += sizeof(object);\
	}

#define PUT_STR(string) {\
	short length = string ? strlen(string) + 1 : 0;\
	if (length > LONG_STR || length < 0) {string[LONG_STR - 1] = 0; length = LONG_STR;}\
	memcpy(ptr, &length, sizeof(length));\
	ptr += sizeof(length);\
	if (length > 0) memcpy(ptr, string, length);\
	ptr += length;\
	}

#define PUT_VALUES(values) {\
	if (values && values[0]) {\
	short count = 1; while(values[count]) count++;\
	count *= sizeof(*values);\
	memcpy(ptr, &count, sizeof(count));\
	ptr += sizeof(count);\
	memcpy(ptr, values, count)\
	ptr += count;\
	} else {memset(ptr, (short)0, sizeof(short));\
	ptr += sizeof(short);}\
	}

#define PUT_ARRAY(array, cnt) {\
	if (array && cnt > 0) {\
	short n = cnt * sizeof(*(array));\
	*((short*)ptr) = n;\
	ptr += sizeof(n);\
	memcpy(ptr, array, n);\
	ptr += n;\
	} else {memset(ptr, (short)0, sizeof(short));\
	ptr += sizeof(short);}\
	}


#define GET(object) {\
	memcpy(&object, ptr, sizeof(object)); \
	ptr += sizeof(object);\
	}

#define GET_STR(string) {\
	short* length = (short*) ptr;\
	ptr += sizeof(*length);\
	if (*length){string = ptr; ptr += *length;}\
	else string = NULL;\
	}

#define GET_VALUES(values) {\
	unsigned short count; memcpy(&count, ptr, sizeof(count));\
	ptr += sizeof(count);\
	if (count) {values = ptr; ptr += count;}\
	else values = NULL;\
	}

#define GET_ARRAY(array, cnt) {\
	unsigned short count; memcpy(&count, ptr, sizeof(count));\
	ptr += sizeof(count);\
	if (count > 0) {memcpy(array, ptr,\
	count > cnt * sizeof(*array) ? cnt * sizeof(*array) : count);\
	ptr += count;}\
	}

#endif



